<?php

 /*
  * BeMail Api
  * Version 1.0.0
  * 
  */
class bemail_api {
    
    private $id;
    private $api_key;
    private $user;
    private $password;
    private $token;
    private $version;
    private $request_url;
    private $url;
    
    function __construct($config)
    {
        $this->request_url = "https://rest.be-mail.it/";
        $this->id = $config['id'];
        $this->api_key = $config['key'];
        $this->user = $config['username'];
        $this->password = $config['password'];
        $this->version = $config['version'];
    }

    public function apiRequest($method = null, $request = null, $fields_post = null)
    {
        $this->generateHash();
        $this->generateRequestUrl($request);
        $method = strtoupper($method);
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $this->url);
        if(isset($method) && !empty($method) && $method = 'POST' && isset($fields_post) && is_array($fields_post))
        {
            curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($fields_post));
        }
        curl_setopt($ch, CURLOPT_HTTPHEADER, array("X-bemail-auth: ".$this->token));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $json = curl_exec($ch);
        
        curl_close($ch);
        
        return $json;
    }

    private function generateHash()
    {
        $hash = md5($this->password.$this->api_key.date('Ymd'));
        $this->token = base64_encode($this->id.'_'.$this->user.'_'.$hash);
    }

    private function generateRequestUrl($request)
    {
        $this->url = $this->request_url.'/'.$this->version.'/'.$request;
    }

}